#!/bin/bash
##########   FoKoN 9.10   ###########\
# Intégration de poste Ubuntu 9.04   #
# dans un domaine Active Directory   #
# géré par IACA.                     #
#------------------------------------#
# Script : maj.sh                    #
# Effectue l'installation et la mise #
# à jour des paquets nécessaires.    #
#                                    #      
#------------------------------------#
# Auteur : Claude CLERC              #
# <claude.clerc@ac-aix-marseille.fr> #
# Site : http://www.fokon.org        #
# Licence : CeCILL - GPL 2.0         #
#####################################/

FOKONDIR=`dirname $0`	# Dossier de ce script.
# On intègre les vérifications d'usage:
. ${FOKONDIR}/common.sh

[ -f ${FOKONDIR}/variables ] || { 
	exit 1
}

. ${FOKONDIR}/variables

TEMPLATES=${FOKONDIR}/templates

### Enregistrement des clés des dépôts supplémentaires
#chmod 750 ${FOKONDIR}/bin/*
for cle in `ls -1A ${FOKONDIR}/Depots/keys` ; do {
	numcle=`echo $cle | sed s/"\.asc"//g`
	echo -e "Enregistrement de la clé de dépôt n° $numcle : "
	cat ${FOKONDIR}/Depots/keys/${cle} | apt-key add -
	sleep 1
}; done

### Dépôts supplémentaires
liste_f="etc/apt/sources.list"
for f in `ls -1A ${FOKONDIR}/templates/etc/apt/sources.list.d | egrep -v "~"`; do {
	liste_f="${liste_f} etc/apt/sources.list.d/${f}"
}; done
transforme
#for f in `ls -1A ${RACINE}/etc/apt/sources.list.d | egrep -v "~"`; do {
#	cat ${RACINE}/etc/apt/sources.list.d/$f >> ${RACINE}/etc/apt/sources.list
#	echo "" >> ${RACINE}/etc/apt/sources.list
#	rm -f ${RACINE}/etc/apt/sources.list.d/$f
#}; done

### Apt-zeroconf
#liste_f="etc/apt-zeroconf.conf"
#transforme

### On force apt-get à utiliser le bon proxy
#OLD_HTTP_PROXY=${http_proxy}
#export http_proxy=""

### Mises à jour
# Transformation éventuelle des source.list pour apt-mirror
[ -x  ${FOKONDIR}/upgrade_after.sh ] && ${FOKONDIR}/upgrade_after.sh
# Accepter les mises à jour de type "update" (noyau, etc.)
liste_f="etc/apt/apt.conf.d/50unattended-upgrades"
transforme
# Màj de la liste des paquets
apt-get update
# Installation des paquets nécessaires
apt-get install --yes `cat ${FOKONDIR}/paquets-necessaires.txt | egrep -v "\#"`
# Installation des paquets utiles
#apt-get install --yes `cat ${FOKONDIR}/paquets-utiles.txt | egrep -v "\#"`
# Màj des paquets eux-mêmes
apt-get --yes upgrade
apt-get --yes dist-upgrade
# Suppression des paquets obsolètes
apt-get --yes autoremove

#export http_proxy="${OLD_HTTP_PROXY}"
