#!/usr/bin/perl
########### FoKoN 9.04-0.6 ##########\
# Intégration de poste Ubuntu 9.04   #
# dans un domaine Active Directory   #
# géré par IACA.                     #
#------------------------------------#
# Script : transforme.pl             #
# Transforme le contenu d'un fichier #
# template, en remplaçant les varia- #
# bles par leurs valeurs, et inscrit #
# le fichier obtenu à la bonne place.# 
#------------------------------------#
# Auteur : Claude CLERC              #
# <claude.clerc@ac-aix-marseille.fr> #
# Site : http://www.fokon.org        #
# Licence : CeCILL - GPL 2.0         #
#####################################/

# Utilisation du jeu de caractères UTF-8
use utf8;
binmode( STDIN,  ':utf8' );
binmode( STDOUT, ':utf8' );

# Variables
%converts= ();	# Tableau de conversions variables -> valeurs
$racine="/";	# Par défaut la racine est /.
$0 =~ /^(.*)\/transforme\.pl$/;	# $0 contient le chemin et le nom du programme, tel qu'il a été appelé (par ex: ./transforme.pl)
$fokondir = $1;	# $1 contient uniquement le chemin, après traitement de la ligne précédente.
open COMMONSH, './common.sh';	# On ouvre le fichier ./common.sh et on lui associe le handler COMMONSH.
@lines= <COMMONSH>;	# On met dans le tableau @lines les lignes du fichier ./common.sh.
foreach $line (@lines) {
	if ($line =~ /^RACINE="(.*)"$/) { $racine= $1; }	# On cherche la ligne qui commence par RACINE=" et finit par ", et on lit la valeur comprise entre les guillemets.
}

$converts{$_}=$ENV{$_} foreach (keys %ENV);

open VARIABLES, './variables';	# On ouvre le fichier ./variables et on lui associe le handler VARIABLES.
@lines= <VARIABLES>;	# On met dans le tableau @lines les lignes du fichier ./variables.
foreach $line (@lines) {
	if ($line =~ /^(.*)="(.*)"$/) { $converts{$1}=$2; }	# Chaque ligne du type variable="valeur" est analysée, et le résultat mis dans converts.
}
#print "$fokondir\n";
#print "$racine\n";
#foreach $key (keys(%converts)) {
#	$value = $converts{$key};
#	print $key . "=" . $value . "\n";
#}


#exit 0;


foreach $file (@ARGV) {
	if ($verbose) { print $file . " --> "; }
	open TEMPLATE, "<$fokondir/templates/$file";
	@lines = <TEMPLATE>;
	close TEMPLATE;
	open FILE, ">$racine/$file";
	if ($verbose) { print $file . "\n"; }
	$line_number = 0;
	foreach $line (@lines) {
		chomp $line; $line_number++;
		# On substitue à la variable son contenu:
		#print "$line_number: $line\n";
		if ($line =~ s/\$\{([^\{]+)\}/$converts{$1}/g) {
			#if ($converts{$1} eq "") {
			#	print "\n\tAttention ! Variable $1 vide à la ligne $line_number du fichier $file. (C'est peut-être normal.)\n";
			#}
		}
		print FILE $line . "\n";
	}
	close FILE;
	# Acquiert les taille, date et permissions du fichier template:
	($filesize, $filedate, $fileperm) = (stat($file))[7,9,2];
	# Formate les permissions en nombre octal de 4 chiffres complété par des zéros à gauche:
	$string = sprintf "%04o", ($fileperm & 07777);
	# Donne les mêmes permissions au fichier créé à partir des templates:
	chmod (oct($string), "$file");

}
exit 0;
